		.globl	_timer_start_measure
		.globl	_timer_stop_measure

| ------------------------------------------------------
		.text
| ------------------------------------------------------
		
_timer_start_measure:
		movem.l	d0-a6,-(sp)			| save for gcc
		
		move.w	#1,d0
		mulu.w	#300,d0				| 300 Hz timer
		move.l	d0,stop_time
		
		move	sr,d2				| save sr
		ori	#0x0700,sr			| ints off
		
		lea	save_mfp,a0			| save mfp
		move.b	0xfffffa09.w,(a0)+		|
		move.b	0xfffffa15.w,(a0)+		|
		move.b	0xfffffa1d.w,(a0)+		|
		move.b	0xfffffa25.w,(a0)+		|

		bset	#4,0xfffffa09.w			| timer-d
		bset	#4,0xfffffa15.w			|
		or.b	#0x07,0xfffffa1d.w		| %111 = divide by 200
		move.b	#41,0xfffffa25.w		| 2457600/200/41 approx 300 Hz

		pea	timer_d
		move.w	#0x110/4,-(sp)
		move.w	#0x05,-(sp)
		trap	#13
		addq.l	#8,sp
		move.l	d0,save_timer_d

		move	d2,sr				| ints back

		movem.l	(sp)+,d0-a6			| restore for gcc
		rts

_timer_stop_measure:
		movem.l	d0-a6,-(sp)			| save for gcc
		
		move	sr,d2				| save sr
		ori	#0x0700,sr			| ints off
		
		move.l	save_timer_d,-(sp)
		move.w	#0x110/4,-(sp)
		move.w	#0x05,-(sp)
		trap	#13
		addq.l	#8,sp
		
		lea	save_mfp,a0			| mfp regs
		move.b	(a0)+,0xfffffa09.w		|
		move.b	(a0)+,0xfffffa15.w		|
		move.b	(a0)+,0xfffffa1d.w		|
		move.b	(a0)+,0xfffffa25.w		|
		
		move	d2,sr				| ints back

		movem.l	(sp)+,d0-a6			| restore for gcc
		rts
		
| Custom Timer D handler

timer_d:	tst.l	stop_time
		beq.b	finished2
		
		subq.l	#1,stop_time

finished2:	bclr	#4,0xfffffa11.w			| clear busybit
		rte

| ------------------------------------------------------
		.bss
| ------------------------------------------------------

save_timer_d:	ds.l	1				| old timer-d
save_mfp:	ds.b	4				| old mfp

stop_time:	ds.l	1

return_code:	ds.b	1

| ------------------------------------------------------
		.text
| ------------------------------------------------------
